Title: Let's go
Date: 2017-03-16 00:00
Category: News
Slug: lets-go
Lang: en

![Let's go][screenshot]


In this article we describe our progress in January and February of 2017: rendering under iOS/Web and a new tutorial tool.

**Rendering under iOS/Web**

To our surprise, we got a simple red cube rendered under [iOS](https://twitter.com/OpenGameStudio/status/826816343433498627) and [Web](https://twitter.com/OpenGameStudio/status/829731986264698881) pretty fast: in early February. However, this is only the beginning of this year's challenge to support Android, iOS, and Web platforms. There's a long and bumpy road ahead of us as we need a lot more on each platform before we can claim a success: visual effects, Python scripting, data archives.

Since it took us about four months to get to mobile and web platforms, we decided to share our knowledge and help OpenSceneGraph community with a guide that shows how to use OpenSceneGraph on desktop, mobile, and web. We believe the more widespread OpenSceneGraph is, the stronger our technology becomes. As Isaac Newton said, "If I have seen further, it is by standing on the shoulders of giants." OpenSceneGraph is our giant.


**Tutorial tool**

Having conducted four live sessions before, it was clear the guide needs videos depicting every nuance. However, bare video alone is only good for showing what to do and not for explaining why do it in a certain way. That's why we decided to combine video with text in the forms of video subtitles and separate articles.

To combine text and video, we first tried [OpenShot](http://openshotvideo.com). It worked well, but we quickly saw its limitations:

* Too much time is spent on adjusting time frames and animations
* Project file and original resources are hard to track with VCS



Since OpenSceneGraph cross-platform guide would consist of several tutorials, we decided to automate the process. Brief research revealed a great multimedia framework called [MLT](http://mltframework.org), which powers OpenShot itself. With MLT we got our tutorial tool in no time.

Currently, the tutorial tool allows anyone to combine text and video using a simple text file like this:
```
background bg.png
text 5 Let's install Blender
video 0:6 install_blender.mp4
text 5 Installing it with apt
video 6:26 install_blender.mp4
text 5 We're still installing it
video 26:56 install_blender.mp4
text 5 Congratulations! We just finished installing Blender
```

This is the actual script. See the final result [here](https://github.com/OGStudio/openscenegraph-cross-platform-guide/tree/master/tutorial-tool).

That's it for describing our progress in January and February of 2017: rendering under iOS/Web and the new tutorial tool.

[screenshot]: {attach}/images/2017-03_lets-go.png
